DataDisplayPage
	parent_type = /htmlobj
	var
		DisplayData/DD = new()
	New()
		..()
		StartScript()
		AddScript(DD.GetJSFunc())
		EndScript()
		StartForm("PersonData",null,null)
		AddBody({"Name: <input type="text" name="name">
<br>Age: <input type="text" name="age">
<input type="button" value="Submit" onclick="DisplayData()">"})
		EndForm()

DisplayData
	parent_type = /jsfunc
	New()
		jsfvars = list("pdata"="*PersonData") // Used for setting up most variables.
		..("DisplayData") // Call to the parent procedure to setup any variables along with function name.
		AddCall("alert",{"*"Hello " + pdata.name.value + "!""}) // Adds a call to the alert function (built-in).  Uses the * operator for more access and control.
		AddCall("alert",{"*"You are " + Number(pdata.age.value) + " years old!""})

ValueCheckPage
	parent_type = /htmlobj
	var
		ValCheckFunc/VCF = new()
	New()
		..()
		StartScript()
		AddScript(VCF.GetJSFunc())
		EndScript()
		StartForm("ValData",null,null)
		AddBody({"Value (0-100): <input type="text" name="val">
<input type="button" value="Submit" onclick="ValCheckFunc()">"})
		EndForm()

ValCheckFunc
	parent_type = /jsfunc
	New()
		jsfvars = list("vdata"="*ValData")
		..("ValCheckFunc")
		If("Number(vdata.val.value) > 100")
		AddCall("alert","Value is greater than 100!")
		EndCondition()
		ElseIf("Number(vdata.val.value) < 0")
		AddCall("alert","Value is less than 0!")
		EndCondition()
		Else()
		AddCall("alert","Value is within range!")
		EndCondition()

HelloWorldPage // Uses handcrafted Javascript for the most part.
	parent_type = /htmlobj
	New()
		..("DisplayHelloWorld()")
		StartScript()
		AddScript({"function DisplayHelloWorld()
{
document.write("Hello World!");
}
"})
		EndScript()

LinkMenuPage
	parent_type = /htmlobj
	var
		HelloWorldPage/HW = new()
		DataDisplayPage/DP = new()
	New(usrc)
		..("")
		AddHtmlObjLink(HW,usrc,null,"Enter Hello World Page")
		AddBody("<br>")
		AddHtmlObjLink(DP,usrc,null,"Enter Data Display Page")

MainDataPage
	parent_type = /htmlobj
	var
		SecondaryDataPage/SDP = new()
	New(usrc)
		..("")
		StartForm(null,"byond://","get")
		AddHtmlObjLinkInput(SDP,usrc)
		AddBody({"Name: <input type="text" name="prname">
<br>Age: <input type="text" name="prage">
<br><input type="submit" value="Submit">"})
		EndForm()


SecondaryDataPage
	parent_type = /htmlobj
	Topic(href,href_list[])
		AddBody({"Name: [href_list["prname"]]
<br>Age: [text2num(href_list["prage"])]"})
		..(href,href_list)

client
	New()
		..()
		src << "Welcome to the Modular HTML Demo!"
		src << "Feel free to try out different verbs and have a peek at different HTML."
	var
		htmlobj/currentpage
	verb
		Data_Display()
			var/DataDisplayPage/DP = new()
			currentpage = DP
			usr << browse(DP.GetHtml())
		Value_Check()
			var/ValueCheckPage/VCP = new()
			usr << browse(VCP.GetHtml())
		Hello_World()
			var/HelloWorldPage/HW = new()
			currentpage = HW
			usr << browse(HW.GetHtml())
		Link_Menu()
			var/LinkMenuPage/LMP = new(src)
			currentpage = LMP
			usr << browse(LMP.GetHtml())
		Main_Data_Page()
			var/MainDataPage/MDP = new(src)
			currentpage = MDP
			usr << browse(MDP.GetHtml())