htmlobj
	var
		headdata
		bodydata
		scriptdata
		bodyonload
	New(onload)
		bodyonload = onload
	Topic(href,href_list[])
		var/client/C = locate(href_list["usr"])
		C << browse(GetHtml())
	proc
		AddHead(data)
			headdata += data
		AddBody(data)
			bodydata += data
		AddHtmlObjLink(htmlobj/link,client/cusr,topicdata,info)
			AddBody("<a href=\"?src=\ref[link];usr=\ref[cusr];[topicdata] \">[info]</a>\n")
		AddHtmlObjLinkInput(htmlobj/link,client/cusr)
			AddBody("<input type=\"hidden\" name=\"src\" value=\"\ref[link]\">\n")
			AddBody("<input type=\"hidden\" name=\"usr\" value=\"\ref[cusr]\">\n")
		GetHtmlObjLink(htmlobj/link,client/cusr,topicdata)
			return "byond://?src=\ref[link];usr=\ref[cusr];[topicdata]"
		StartForm(id,action,method)
			AddBody("<form id=\"[id]\" action=\"[action]\" method=\"[method]\">\n")
		EndForm()
			AddBody("</form>\n")
		StartScript()
			scriptdata += "<script type=\"text/javascript\">\n"
		AddScript(data)
			scriptdata += "[data]"
		EndScript()
			scriptdata += "</script>"
		GetHtml()
			var/htmldata = {"<html>
<head>"}
			if(headdata != null)
				htmldata += "\n[headdata]"
			if(scriptdata != null)
				htmldata += "\n[scriptdata]"
			htmldata += {"\n</head>
<body onload="[bodyonload]">"}
			if(bodydata != null)
				htmldata += "\n[bodydata]"
			htmldata += {"\n</body>
</html>"}
			return htmldata

#ifdef MH_JAVASCRIPT
var
	const
		JS_PREFIX = 0x00
		JS_POSTFIX = 0x01

		JS_DOWHILESTART = 0x00
		JS_DOWHILEEND = 0x01

jsfunc
	var
		jsfuncname
		jsfuncdata
		list
			jsfargs = new()
			jsfvars = new()
	New(jsfuncname)
		src.jsfuncname = jsfuncname
		for(var/V in jsfvars)
			AddVar("[V]",jsfvars["[V]"])
	proc
		AddVar(varname,data)
			jsfuncdata += "\nvar [varname]"
			if(istext(data))
				if(copytext(data,1,2) == "*")
					jsfuncdata += " = "
					jsfuncdata += copytext(data,2,length(data)+1)
					jsfuncdata += ";"
				else
					jsfuncdata += " = \"[data]\";"
			else if(isnum(data))
				jsfuncdata += " = [data];"
			else if(istype(data,/jsobj))
				var/jsobj/JSO = data
				jsfuncdata += " = new [JSO.jsfuncname]("
				for(var/A in args)
					if(A == varname || A == data)
						continue
					if(A != args[3])
						jsfuncdata += ","
					if(istext(A))
						jsfuncdata += "\"[A]\""
					else
						jsfuncdata += "[A]"
				jsfuncdata += ");"
			else if(istype(data,/jsfunc))
				var/jsfunc/JSF = data
				jsfuncdata += " = [JSF.jsfuncname];"
			else
				jsfuncdata += ";"
		SetVar(varname,operator,data)
			jsfuncdata += "\n[varname]"
			if(istext(data))
				if(copytext(data,1,2) == "*")
					jsfuncdata += " [operator]= "
					jsfuncdata += copytext(data,2,length(data)+1)
					jsfuncdata += ";"
				else
					jsfuncdata += " = \"[data]\";"
			else if(isnum(data))
				jsfuncdata += " [operator]= [data];"
			else if(istype(data,/jsobj))
				var/jsobj/JSO = data
				jsfuncdata += " = new [JSO.jsfuncname]("
				for(var/A in args)
					if(A == varname || A == operator || A == data)
						continue
					if(A != args[4])
						jsfuncdata += ","
					if(istext(A))
						jsfuncdata += "\"[A]\""
					else
						jsfuncdata += "[A]"
				jsfuncdata += ");"
			else if(istype(data,/jsfunc))
				var/jsfunc/JSF = data
				jsfuncdata += " = [JSF.jsfuncname];"
			else
				jsfuncdata += ";"
		AdjustVar(varname,operator,flag)
			if(flag & JS_POSTFIX)
				jsfuncdata += "\n[varname][operator];"
			else
				jsfuncdata += "\n[operator][varname];"
		AddCall(funcname)
			jsfuncdata += "\n[funcname]("
			for(var/A in args)
				if(A == funcname)
					continue
				if(A != args[2])
					jsfuncdata += ","
				if(istext(A))
					if(copytext(A,1,2) == "*")
						jsfuncdata += copytext(A,2,length(A)+1)
					else
						jsfuncdata += "\"[A]\""
				else
					jsfuncdata += "[A]"
			jsfuncdata += ");"
		If(condition)
			jsfuncdata += "\nif([condition])\n{"
		ElseIf(condition)
			jsfuncdata += "\nelse if([condition])\n{"
		Else()
			jsfuncdata += "\nelse\n{"
		While(condition)
			jsfuncdata += "\nwhile([condition])\n{"
		DoWhile(flag,condition)
			if(!(flag & JS_DOWHILEEND))
				jsfuncdata += "\ndo\n{"
			else
				jsfuncdata += "\n}\nwhile([condition]);"
		For(ival,condition,operation)
			jsfuncdata += "\nfor([ival]; [condition]; [operation])\n{"
		EndCondition()
			jsfuncdata += "\n}"
		GetJSFunc()
			var/jsfunc = "function [jsfuncname]("
			for(var/A in jsfargs)
				if(A != jsfargs[1])
					jsfunc += ","
				jsfunc += "[A]"
			jsfunc += {")
{[jsfuncdata]
}\n"}
			return jsfunc

jsobj
	parent_type = /jsfunc
	var
		list
			jsovars
	New()
		..()
		for(var/V in jsovars)
			SetObjVar("[V]",null,jsovars["[V]"])
	proc
		SetObjVar(varname,operator,data)
			jsfuncdata += "\nthis.[varname]"
			if(istext(data))
				if(copytext(data,1,2) == "*")
					jsfuncdata += " [operator]= "
					jsfuncdata += copytext(data,2,length(data)+1)
					jsfuncdata += ";"
				else
					jsfuncdata += " = \"[data]\";"
			else if(isnum(data))
				jsfuncdata += " [operator]= [data];"
			else if(istype(data,/jsfunc))
				var/jsfunc/JSF = data
				jsfuncdata += " [operator]= [JSF.jsfuncname];"
			else
				jsfuncdata += ";"
		AdjustObjVar(varname,operator,flag)
			if(flag & JS_POSTFIX)
				jsfuncdata += "\nthis.[varname][operator];"
			else
				jsfuncdata += "\n[operator]this.[varname];"
#endif